<?php

namespace App\Http\Controllers;

use App\Http\Requests\SpecialityRequest;
use App\Http\Resources\SpecialityResource;
use App\Services\SpecialityService;
use Illuminate\Http\JsonResponse;

class SpecialityController extends Controller
{
    public function __construct(
        protected SpecialityService $service,
    ) {}

    public function index(): JsonResponse
    {
        $items = $this->service->getAll();

        return $this->successResponse(payload: SpecialityResource::collection($items));
    }

    public function store(SpecialityRequest $request): JsonResponse
    {
        $item = $this->service->create($request->validated());

        return $this->successResponse(payload: new SpecialityResource($item), message: __('messages.created'), code: 201);
    }

    public function show(int $id): JsonResponse
    {
        $item = $this->service->findById($id);

        return $this->successResponse(payload: new SpecialityResource($item));
    }

    public function update(SpecialityRequest $request, int $id): JsonResponse
    {
        $item = $this->service->update($id, $request->validated());

        return $this->successResponse(payload: new SpecialityResource($item), message: __('messages.updated'));
    }

    public function destroy(int $id): JsonResponse
    {
        $this->service->delete($id);

        return $this->successResponse(message: __('messages.deleted'), code: 204);
    }
}
